<?php  if (!defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| URI ROUTING
| -------------------------------------------------------------------------
| This file lets you re-map URI requests to specific controller functions.
|
| Typically there is a one-to-one relationship between a URL string
| and its corresponding controller class/method. The segments in a
| URL normally follow this pattern:
|
| 	www.your-site.com/class/method/id/
|
| In some instances, however, you may want to remap this relationship
| so that a different class/function is called than the one
| corresponding to the URL.
|
| Please see the user guide for complete details:
|
|	http://www.codeigniter.com/user_guide/general/routing.html
|
| -------------------------------------------------------------------------
| RESERVED ROUTES
| -------------------------------------------------------------------------
|
| There are two reserved routes:
|
|	$route['default_controller'] = 'welcome';
|
| This route indicates which controller class should be loaded if the
| URI contains no data. In the above example, the "welcome" class
| would be loaded.
|
|	$route['scaffolding_trigger'] = 'scaffolding';
|
| This route lets you set a "secret" word that will trigger the
| scaffolding feature for added security. Note: Scaffolding must be
| enabled in the controller in which you intend to use it.
|
*/

$route['default_controller'] = "home";
$route['scaffolding_trigger'] = "";

$route['status']="home/status";
$route['bug']="home/bug";

$route['feed']="feed/index";
$route['feed/comments/(:any)']="feed/comments/$1";

$route['parts']="parts";
$route['parts/sort/(:any)']="parts/index/$1";

$route['parts/save']="parts/save";
$route['catalogue']="catalogue/index";
$route['catalogue/(:any)']="catalogue/index/$1";

$route['parts/(:num)']="parts";
$route['parts/getPartLocations']="parts/getPartLocations";
$route['parts/(:any)']="parts/single/$1";

$route['processes']="processes";
$route['processes/(:num)']="processes";

$route['endoflife']="endoflife";
$route['endoflife/(:num)']="endoflife";

$route['transport']="transport";
$route['transport/(:num)']="transport";

$route['transport/transport-(:num)']="transport/single/$1";
$route['users/(:num)']="users/index/$1";
$route['users']="users/index";

$route['user/(:any)']="users/single/$1";
$route['dashboard']="users/single";

$route['collection/(:any)']="collections/collection/$1";
$route['collections/(:num)']="collections";

$route['comments']="comments/index";
$route['comments/save']="comments/save";
$route['comments/update']="comments/update";

$route['map/(:num)']="map/index/$1";
$route['map/simple/(:num)']="map/simple/$1";
$route['map/embed/(:num)']="home/page_not_found/map/$1"; #0.7.5 Compatibility
$route['map/embed/(:any)']="map/embed/$1";

$route['search/(:any)']="search/index/$1";

$route['objects']="objects";
$route['objects/about']="objects/about";

$route['objects/object-(:num)']="home/page_not_found/obj/$1"; #0.7.5 Compatibility
$route['objects/travel-(:num)']="home/page_not_found/obj/$1"; #0.7.5 Compatibility
$route['objects/food-(:num)']="home/page_not_found/obj/$1"; #0.7.5 Compatibility

$route['objects/sort/(:any)']="objects/index/$1";
$route['objects/(:num)']="objects";
$route['objects/save']="objects/save";
$route['objects/create']="objects/create";

$route['objects/(:any)']="objects/$1";

$route['api']= "api/index";
$route['api/json/(:num)']="api/json/$1";
$route['api/kml/(:num)']="api/kml/$1";
$route['api/carbon/embodied/(:any)']="api/embodiedcarbon/$1";
$route['api/carbon/transport/list/methods']="api/transportmethods";
$route['api/carbon/transport/(:any)/(:any)/(:any)']="api/transportcarbon/$1/$2/$3";
$route['api/(:any)/create']="api/create/$1";
$route['api/(:any)/update']="api/update/$1";

$route['sitemap']="sitemaps/index";
$route['sitemap-xml']="sitemaps/xmlmap";

$route['groups/(:num)']="groups/index/$1";
$route['groups']="groups/index";
$route['group/create']="groups/create";
$route['group/update']="groups/update";
$route['group/(:any)']="groups/single/$1";

# Categories route laste
$route['food/(:any)']="objects/single/$1/food";
$route['object/(:any)']="objects/single/$1/object";
$route['travel/(:any)']="objects/single/$1/travel";
$route['trace/(:any)']="objects/single/$1/trace";
$route['sourcemap/(:any)/(:any)']="objects/single/$2/$1";

$route['vcard']="home/vcard";

?>