<?php
/**
 * Controller for getting catalogues (parts & sourcemaps).
 * 
 * @version 0.8.0
 * @author sourcemap@media.mit.edu
 * @package sourcemap
 * @subpackage controllers
 * @uses CatalogueModel
 */
class Catalogue extends SM_Controller {		
	public function Catalogue() {
		parent::SM_Controller();
		$this->load->model(Array('CatalogueModel'));		
	}
	
	/**
	 * Default controller, outputs a catalogue for ajax load.
	 * @param $sort string the order to sort the catalogue in
	 * @uses color string text pagination	
	 */
	public function index($sort="name"){	
		$this->load->helper(Array('string', 'text', 'color', 'locale'));
		$this->load->library('pagination');
		
		if($this->input->post('filter')) { $filter = $this->input->post('filter');} else { $filter = ""; }
		if($this->input->post('type')) { $type = $this->input->post('type');} else { $type = "object"; }
		if($this->input->post('typefilter')) { $typefilter = $this->input->post('typefilter');} else { $typefilter = ""; }
				
		if($sort == "name") { $partsort = 'name ASC'; }
		if($sort == "category") { $partsort = 'type ASC, name ASC'; }			
		if($sort == "emissions") { $partsort = 'emissions ASC'; }
		if($sort == "namedesc") { $partsort = 'name DESC'; }
		if($sort == "categorydesc") { $partsort = 'type DESC, name ASC'; }			
		if($sort == "emissionsdesc") { $partsort = 'emissions DESC'; }
		
		$range = ($this->uri->segment(3)) ? ($this->uri->segment(3)) : 0;
		$pageper = 30; 
		$pagetotal = $this->CatalogueModel->getCatalogueTotal($filter, $typefilter);		
		$this->data("total", $pagetotal);	
		$parts = $this->CatalogueModel->getCatalogue($pageper, $range, $partsort, $filter, $typefilter);
		
		$max = 0; foreach($parts as $part) { $max = max($max,$part->emissions);}
		foreach($parts as $part) { $part->color = findcolor($part->emissions, $max, 0, "greentored", "0.1");}
		$this->data('type', $type);
		$this->data('partsArray', $parts);	
		$this->data("sort", $sort);						
		$this->output->set_output($this->display("Catalogue", "catalogue_view", false, true));
	}
	
} // End Catalogue
