<?php
/**
 * Controller for displaying atom feeds from sourcemap.
 * 
 * @version 0.8.0
 * @author sourcemap@media.mit.edu
 * @package sourcemap
 * @subpackage controllers
 * @uses CommentsModel ObjectsModel xml
 */
class Feed extends SM_Controller {
    public function Feed() {
        parent::SM_Controller();
        $this->load->model(Array('ObjectsModel', 'CommentsModel'));
        $this->load->helper('xml');
    }
    
	/**
	 * Displays an atom feed of sourcemaps.
	 * @param string $sort How objects should be sorted (default timemodified DESC).
	 * @todo Better expose sorts, add parameters for filtering.
	 */
    public function index($sort='timemodified DESC') {		
       	$this->data('objects',$this->ObjectsModel->getObjects(10, null, $sort));   
        $this->output->set_header("Content-Type: application/atom+xml");
		$this->display("Feed", "feeds/feed_view");
    }

    /**
     * Shows a feed for the comments of a given sourcemap.
	 * @param $slug string The sourcemap.
     */
    public function comments($slug) {		
		$object = $this->ObjectsModel->getObject($slug);
		$this->data('object',$object);   
		$this->data('comments', $this->CommentsModel->getComments("object", $object->oid));
		$creatorid = $object->creator;
		$this->data("creator", $this->UsersModel->getUserById($creatorid));
		$this->output->set_header("Content-Type: application/atom+xml");
		$this->display("Comment Feed", "feeds/feedcomment_view");
    }
} // End Feed