<?php
/**
 * Controller for searching sourcemap..
 * 
 * @version 0.8
 * @author sourcemap@media.mit.edu
 * @package sourcemap
 * @subpackage controllers
 */
class Search extends SM_Controller{		
	public function Search(){
		parent::SM_Controller();
		$this->load->model(Array('AuthModel','CatalogueModel','PartsModel','UsersModel'));				
	}
	
	/**
	 * Searches objects and carbon catalogue
	 * @param $searchTerm the search term (if not POSTed).
	 */
	public function index($searchTerm=""){
		if($this->input->post('searchTerm')) { 
			$filter = $this->input->post('searchTerm');
		} else { $filter = $searchTerm; }
		if($filter == "") {
			$title = "Search";			
		} else {
			$title = "Search results for ".$filter;			
		}

		$this->load->helper(Array('string', 'text', 'color'));
		$this->load->library('pagination');			
		$sort = 'name ASC';
		$range = ($this->uri->segment(3)) ? ($this->uri->segment(3)) : 0;
		$pageper = 30; 
		$pagetotal = $this->CatalogueModel->getCatalogueTotal($filter);		
		$this->data("total", $pagetotal);	
		$parts = $this->CatalogueModel->getCatalogue($pageper, $range, $sort, $filter);
		foreach($parts as $part) {
			$part->color = findcolor($part->emissions, 500, 0, "greentored", "0.1");
		}
		$this->paginate($pageper,site_url() . '/search/'.$filter.'/',$pagetotal,3);
		
		$this->data('partsArray', $parts);	
		$this->data('searchTerm', $filter);
		$this->data("sort", $sort);
		$this->style(Array('search.css'));			
						
		$this->display($title, "search_view.php");	
	}
}