<?php

/**
 * Representation of objects as model, handles transactions for
 * objects so they can be listed or edited. 
 * 
 * @author Sourcemap Team
 * @package sourcemap
 * @subpackage models
 */



class CatalogueModel extends Model {
	
	function CatalogueModel(){
		parent::Model();	
		// set visible instead of where visiblity, where private
	}
	/**
	 * Gets the count from the parts_list and objects_complex tables
	 */
	function getCatalogueTotal($filter="", $typefilter="") {
		$objects = $this->db->query("SELECT count(*) FROM objects_complex LEFT OUTER JOIN (select oid as pid, count(oid) as partcount from parts_instantiated group by pid) as parts_instantiated ON parts_instantiated.pid = objects_complex.oid WHERE partcount > 1 AND visibility != 'private' AND flag != 'temporary' AND (name||description||type||origin) ILIKE '%".$filter."%' AND type ILIKE '%".$typefilter."%'");
		$objects = $objects->result();		
		$objects = $objects[0]->count;

		$parts = $this->db->query("SELECT count(*) FROM parts_list WHERE approval_status = 'approved' AND (name||description||class) ILIKE '%".$filter."%' AND class ILIKE '%".$typefilter."%'");
		$parts = $parts->result();
		$parts = $parts[0]->count;
		return $objects + $parts;	
	}

	/**
	 * Returns the information from objects_complex table and the approved parts from the parts_list table
	 * @orderby name is ascending order
	 * @limit int $pageper=30
	 * 
	 */
	function getCatalogue($pageper=30, $range=0, $partsort="name ASC", $filter, $typefilter=""){
	
		if($filter != "") {
			$objectfilter = " AND (name||description||type||origin) ILIKE '%".$filter."%'";
			$partfilter = " AND (name||description||class) ILIKE '%".$filter."%'";			
		} else { $objectfilter = ""; $partfilter = ""; }
		if($typefilter != "") {
			$typeobjectfilter = " AND type ILIKE '%".$typefilter."%'";
			$typepartfilter = " AND class ILIKE '%".$typefilter."%'"; 
		} else { $typeobjectfilter = ""; $typepartfilter = ""; }
			
		$objects = $this->db->query("(SELECT objects.oid as id, objects.type as type, objects.name as name, objects.slug as slug, objects.origin as origin, objects.weight as weight, objects.shipping as shipping, objects.emissions as emissions, objects.description as description FROM objects_complex objects LEFT OUTER JOIN (select oid as pid, count(oid) as partcount from parts_instantiated group by pid) as parts_instantiated ON parts_instantiated.pid = objects.oid WHERE partcount > 1 AND objects.visibility != 'private' AND objects.flag != 'temporary' ".$objectfilter.$typeobjectfilter.") UNION (SELECT parts.id as id, parts.class as type, parts.name as name, parts.slug as slug, null, null, null, parts.co2_eq as emissions, parts.description as description FROM parts_list parts WHERE parts.approval_status = 'approved'".$partfilter.$typepartfilter.") ORDER BY ".$partsort. " LIMIT ".$pageper." OFFSET $range");
		$objects = $objects->result();
		return $objects;
	}
}

?>