<?php

/**
 * Representation of comments as model, handles transactions for
 * comments or discussions so they can be listed or edited. 
 * 
 * @author Matthew Hockenberry
 * @package sourcemap
 * @subpackage models
 */



class CommentsModel extends Model{
	
	/**
	 * @ignore
	 */
	function CommentsModel(){
		parent::Model();	
		$this->load->model('AuthModel');
		$this->load->model('objectsModel');
	}	
	
	/**
	 * Gets All Comments for a given object.
	 * @param string $type The kind of comment 
	 * @param integer $id The id 
	 * @return Object Object containing comment properties or false if none selected.
	 */
	function getComments($type, $id){
			$this->db->select('*');		
			$this->db->from('comments');
			$this->db->where('type', $type);
			
			$this->db->where('refid', $id);

			$query = $this->db->get();
			
			return array_reverse($query->result());
	}
	
	function saveComment($comment) {					
		$currentuser = $this->AuthModel->getCurrentUser();
		$currentemail = $this->AuthModel->getCurrentUserEmail();
		
		$data = array(
		'comment' => utf8_decode($comment->text),
		'author' => $currentuser,
		'refid' => $comment->id,
		'type' => $comment->type,
		'authoremail' => $currentemail				
		);
		
		$this->db->insert('comments', $data);
		$this->output->set_output(md5($currentemail));		
	}
	
	function addFavorite($favorite) {
		$currentuserid = $this->AuthModel->getCurrentUserID();
		
		if($favorite->status == "remove") {
			$this->db->where('oid', $favorite->id);
			$this->db->delete('favorites');
		}
		else {
			$data = array(
			'oid' => $favorite->id,
			'uid' => $currentuserid,
			);
		
			$this->db->insert('favorites', $data);
		}
	}
	
	function checkFavorite($id) {
		if($this->AuthModel->checkUserLogin()) {
			$currentuserid = $this->AuthModel->getCurrentUserID();
		
			$this->db->select('*');		
			$this->db->from('favorites');
			$this->db->where('oid', $id);
			$this->db->where('uid', $currentuserid);
			$query = $this->db->get();
			
			if(count($query->result()) > 0) { return true; }
			else { return false; }
		}
	}

	

	

  }
?>