<?php

/**
 * Representation of power methods as model
 * 
 * @package sourcemap
 * @subpackage models
 */

class PowerModel extends Model{
	
	/**
	 * @ignore
	 */
	function PowerModel(){
		parent::Model();	
	}	
	
	/**
	 * Gets the list of all power methods 
	 * @param 
	 * @return result from power table 
	 */
	function getPowerList(){
			$this->db->select('*');		
			$this->db->from('power');

			$query = $this->db->get();
			return $query->result();
	}


	/**
	 * Gets the list of all power methods.
	 * @return Array, array of all power methods
	 * @param integer $limit, Limit number of power methods
	 * @param integer $offset, offset to return power methods
	 * @param string $sort. How power methods should be sorted (name ASC)
	 */
	function getPowerMethods($limit = null, $offset =null, $sort = 'powersource ASC') {
	  $this->db->select('*');
	  $this->db->from('power');
	  $this->db->order_by($sort);
	  $this->db->limit($limit, $offset);
	  $query = $this->db->get();
	  return $query->result();
	}


	/**
	 * Return the total size of the power methods table
	 * @return int Number of power methods.
	 */
	function getPowerCount() {
	  return $this->db->count_all_results('power');
	}


}
?>