<?php

/**
 * Representation of transport methods as model
 * 
 * @package sourcemap
 * @subpackage models
 */

class ProcessesModel extends Model{
	
	/**
	 * @ignore
	 */
	function ProcessesModel(){
		parent::Model();	
	}	
	


	/**
	 * Gets the list of all processes methods.
	 * @return Array Array of all processes methods.
	 * @param integer $limit Limit number of processes methods.
	 * @param integer $offset Offset to return processes methods.
	 * @param string $sort How processes methods should be sorted (name ASC).
	 */
	function getProcessesMethods($limit = null, $offset = null, $sort = 'name ASC'){
		$this->db->select('*');		
		$this->db->from('processes');
		
		$this->db->order_by($sort);		
		
		$this->db->limit($limit, $offset);
		
		$query = $this->db->get();
		return  $query->result();
	}
	
	/**
	 * Returns the total size of the processes methods table.
	 * @return int Number of processes methods.
	 */
	function getProcessesCount(){
		return $this->db->count_all_results('processes');
	}
}
?>