<?php

/**
 * Representation of tags as model, handles transactions for
 * tags so they can be clouded or edited. 
 * 
 * @author Sooyeon Jeong
 * @package sourcemap
 * @subpackage models
 */

class TagsModel extends Model{
	
	/**
	 * @ignore
	 */
	function TagsModel(){
		parent::Model();	
	}	
	

	/**
	 * Returns the object from tags table
	 * @param string $tp, int $idnum
	 * @orderby name, id in ascending order
	 */
	function getTags($tp, $idnum){
		$this->db->select('*');
		$this->db->from('tags');
		$this->db->order_by('name ASC, id ASC');
		
		if ($tp!='null') {
			$this->db->where('type', $tp);
		}
		
		if ($idnum!='null') {
			$this->db->where('id', $idnum);
		}
	
		$query = $this->db->get();
			
		return $query->result();
	}

	/**
	 * Inserts the data into the tags table
	 * @param string $tagname, int $mid
	 */
	function addTags($tagname, $mid) {
		$data = array(
		//	'tig' => 
			'type' => 'part',
			'name' => $tagname,
			'id' => $mid
		);
	
		$this->db->insert('tags', $data);
	}
	
	/**
	 * Count the occurence of the same tag in the database
	 * @param array $tagslist
	 */

	function occurenceCheck($tagsList) {
		$temp_name = 'null';
		$temp_i = 0;
		$count = 0;
		$i = 0;
		$max = 0;
		$min = 999999999999;
		foreach ($tagsList as $tags) {
			if ($temp_name == $tags->name) {
				$count++;
				$occurence[$i] = 0;
			} else {
				if ($temp_name != 'null') {
					$occurence[$i] = $count;
				}
				$occurence[$temp_i] = $count;
				$temp_name = $tags->name;
				
				if ($max < $occurence[$temp_i]) $max = $occurence[$temp_i];
				if ($min > $occurence[$temp_i] && $occurence[$temp_i] != 0) $min = $occurence[$temp_i];
				
				// initialize the count again
				$temp_i = $i;
				$count = 1;
			}
			$i++;
		}
				
		if ($count >= 1) {
			$occurence[$temp_i]	= $count;
			if ($max < $occurence[$temp_i]) $max = $occurence[$temp_i];
			if ($min > $occurence[$temp_i] && $occurence[$temp_i] != 0) $min = $occurence[$temp_i];
		} 
					
		$i = 0;
		$step = ($max - $min + 1) / 4;
	
		foreach ($tagsList as $tags) {
			if ($occurence[$i] > 0) {
				$occurence[$i] = ($occurence[$i] - $min) / $step + 1;	
			}
			$i++;
		}
		
		return $occurence;
	}
		
	/**
	 * Returns the total size of the tag table.
	 * @return int Number of tags.
	 */
	function getTagCount(){
		return $this->db->count_all_results('tagsArray');
	}		
}
?>