<!DOCTYPE html>
<html>
<head>
	<title><?=$title?> on Sourcemap</title>
	<link rel="alternate" type="application/rss+xml" title="Comments" href="<?=base_url();?>feed/comments/<?=$object->slug;?>" />
	<?=$styles;?>
	<?=$headerDisplay;?>
	<meta name="geo.position" content="<?=array_shift(explode("|",$object->latlon));?>; <?=array_pop(explode("|",$object->latlon));?>"> 
	<meta name="geo.placename" content="<?=$object->origin;?>">
</head>

<body class="objectdisplay" id="<? if(isset($type)) { echo $type;} ?>">	

<?=$navigationDisplay;?>
<div id="wrapper">
<div id="subwrapper">		
<div id="maindiv">

<?if($editable || $object->visibility != "private") {?>

<!-- Object Summary -->	
<div id="sourcemap" class="supplychain summary">
	<? if($object->imagelink != "") { ?>
		<img src="<?=$object->imagelink;?>" style="float:left; margin-left:-90px; width:80px; height:77px;"/>
	<?}?>
	<h1>
		<span id="object-name"><?= ($object->name);?></span>
		<span id="object-travel">
			<?=getTemplateTerm($type, "madein");?> 
			<span id="object-origin"><?= ($object->origin);?></span>
		</span>	
	</h1>

	<h4>
		<img style="display:inline;" src="<?= sprintf( 'http://www.gravatar.com/avatar/%s?d=%s&s=%d&r=%s', md5( $object->user->email ), 'identicon', 16, 'pg' ); ?>" alt="favicon for <?= $object->user->email;?>" width="16" height="16" /> 
		<strong class="label">Added by </strong><a href="<?=site_url();?>user/<?=$object->user->name;?>">
		<span id="object-creator"><?= $object->user->name;?></span></a>
		<span id="modified">and modified</span> 
		<span id="object-modified"><?= fuzzy_time($object->timemodified);?>.</span>
	</h4>
	
	<h4>
		<?= word_limiter(strip_tags($object->description, '<a>'),8);?> 
		<span id="more-description-button">(more)</span>
	</h4>
	
	<span class="footprint hidden">Carbon Footprint for <?= ($object->name);?></span>
	<div class="oid hidden">
		<span class="label">Object Id</span>
		<span class="id" id="object-oid"><?= $object->oid;?></span>
	</div>
	<div class="geo hidden">
		<span class="latitude"><?=array_shift(explode("|",$object->latlon));?></span>
		<span class="longitude"><?=array_pop(explode("|",$object->latlon));?></span>
	</div>
	<?= $actionsDisplay; ?>
	
	<div id="delivered-panel">
		<span id="lastleg-punch-block">To have this delivered to you in <input id="lastleglocation"/ > via <span id="lastlegselect"></span> would be an additional <span id="lastlegemissions">0</span>kg CO2e
	</div>
	<div id="share-panel">
		<div id="viewbadged" class="share-group">
			<h4>View</h4>
			<ul>
				<li><a href="<?=site_url()."map/fullscreen/".$object->slug;?>">Fullscreen Map</a></li>
				<li id="globe-view"><a href="<?=site_url()."map/globe/".$object->slug;?>">Google Earth Globe</a></li>
			</ul>
		</div>
		<div id="sharebadged" class="share-group" >		
			<h4 id="share-object">Share</h4>
			<ul id="share-options">
				<li><a id="embedexportjump" class="thickbox" href='<?=site_url()."map/embed/".$object->slug."/code?height=440&width=455";?>' title="Embed a Sourcemap">Embed a Sourcemap</a>	
				</li>
				<li><a id="embedexportjump" href='<?=site_url()."map/printer/".$object->slug."";?>' title="Embed a Sourcemap">Print a Sourcemap</a>	
				</li>
			</ul>
		</div>
		<div id="developbadged" class="share-group">
			<h4>Develop</h4>
			<ul>
				<li><a href="<?=site_url()."api/json/".$object->slug;?>">JSON File Download</a></li>
				<li id="globe-view"><a href="<?=site_url()."api/kml/".$object->slug;?>">KML File Download</a></li>
			</ul>
		</div>
	</div>

	<ul id="permission-panel">
		<h4>Editing</h4>						     
		<li class="permission_user <? if ($permission_type == "useredit"){ echo "selected"; } ?>">You</li> 
			  
		<? if(count($groups) > 0) {?>
		<li class="permission_group <? if ($permission_type == "groupedit"){ echo "selected"; } ?>"> 						    
			<select name="Groupedit" id="groupedit">
				<? foreach($groups as $group) { ?>				  			   
				    <option value="<?= $group->name;?>"><?= $group->name;?></option> 
				<? } ?>
			</select>
		</li><? } ?>

		<li class="permission_everyone <? if ($permission_type == "everyoneedit"){ echo "selected"; } ?>">Everyone</li> 
						    
		<h4>Visibility</h4>
		<li class="permission_public <? if ($permission_objects == "public") { echo "selected"; } ?>">Public</li>

		<li class="permission_private <? if ($permission_objects == "private") { echo "selected"; } ?>">Private</li>
		<div class="clear"><br/></div><br/>    
	</ul>
</div> 
<div style="clear:both;"></div>
<!-- End Summary -->

<!-- Map -->
<div id="smbadge"></div><?= $mapDisplay;?>

<!-- Visualizations -->
<ul id="visualizations-menu">
	<? if($editable) { ?>
		<li class="editor" id="editsourcemapbutton">Edit Sourcemap</li>
		<li class="editor" id="savesourcemapbutton">Save Sourcemap</li>
		<li class="editor" id="addpartbutton">Add <?= getTemplateTerm($type, "part");?></li>
	<? } ?>
	<li class="comment-visualization-button">Comments (<span id="commentcount"><?= count($comments); ?></span>)</li>		
	<li class="charting-visualization-button">Bar Chart</li>	
	<li class="right partlist-visualization-button"><?= getTemplateTerm($type, "partlistlabel"); ?></li>	
</ul>

<?= $pieDisplay; ?>
<?= $commentsDisplay; ?>

<? if($editable) { ?>
<div class="visualization" id="partchooser-visualization">
	<div class="visualization-menu">Add a part <div class="visualization-close-button">x</div></div>
	<div class="visualization-shell" id="partchooserbox">
		<div id="cataloguemenu">
			<div style="margin-left:15px; float:left;">Filter <input id="filter" type="text" name="filter" value=""/> and sort by 
				<span class="cataloguesort" id="name">Name</span> &bull;
				<span class="cataloguesort" id="category">Category</span> &bull;
				<span class="cataloguesort" id="emissions">Emissions</span> 		
			</div>
			<div class="pagination"></div><div class="clear"></div>
		</div>
		<div id="partchooser">	
			<div id="carboncatalogue"><div id="catalogueshell"></div></div>				
		</div>
	</div>
</div>
<? } ?>

<?= $partsDisplay; ?>
<!-- End Visualizations -->

<!-- Transport Template -->
<div class="callout hidden">Shipped To: <span id="object-destination"><?= ($object->destination);?></span><strong class="label">Via:</strong><span id="object-via"> 
	<select name="transportlist" class="input-via">
		<?php foreach($transports as $transport):?> <option <? if($transport->name == "None Selected") { ?>SELECTED <? } ?>value="<?=$transport->co2_eq;?>"><?=$transport->name;?></option><?php endforeach;?>
	</select></span> 
</div>

<?} else {?><h1 style="text-align:center;">This Sourcemap is Private.</h1><?}?>
	
</div>

<!-- Object Description -->
<h2 id="object-story">
	<span id="object-description"><?= $object->description;?></span>
</h2>
<!-- End Object Description -->

</div>		
<?=$footerDisplay;?>	
</div>		
<div id="bottom"></div>
<?=$scripts;?>
</body>
</html>
