/**
 * Sourcemap.Collections: Used for dynamic content in the collections page.
 * 
 * @version 0.8
 * @author sourcemap@media.mit.edu
 * @package sourcemap
 * @subpackage js
 */

if ( typeof(Sourcemap) == 'undefined' ) {Sourcemap = {};}

Sourcemap.Collections = {	
  init: function() {
	var keyword = "";
	var mapkeyword = "";
	var listkeyword = "";
	var type = "textual";
	var operator = "ILIKE";
	var listajaxopen = true;
	var mapajaxopen = true;
	
	var offset = 0;
	
	var SMap = new Sourcemap.OpenMultiSourcemap('smap',objectsConfig, otherObjects,
		{ navPosition: new OpenLayers.Pixel(2,2)});	
	if(typeof(mapMode) != 'undefined') {
		if(GBrowserIsCompatible()){	
			SMap.geoCoder = new GClientGeocoder();
		}	
	}
	
	var updateMap = function(objects) {
			if(mapkeyword != $('#filter-by').val() && mapkeyword != "*") {
				if($('#filter-by').val() == "") { mapkeyword = "*";}
				else { mapkeyword = $('#filter-by').val(); }
				console.log("map keyword is " + mapkeyword);
				$.post(Sourcemap.baseurl+"collections/filtermap", { keyword: mapkeyword, type: type, operator: operator, id: collectionID}, updateMap, "json");
			} else {
				console.log("updating map");				
				mapajaxopen = true;									
				SMap.refreshMap(objects, []);
			}
		
	};
	
	var updateList = function(html) {
			console.log("updating list===");
			if(listkeyword != $('#filter-by').val() && listkeyword != "*") {
				if($('#filter-by').val() == "") { listkeyword = "*";}
				else { listkeyword = $('#filter-by').val(); }
			
				$.post(Sourcemap.baseurl+"collections/filterlist", { keyword: listkeyword, type: type, operator: operator, id: collectionID, offset:-1}, updateList, "html");
			} else {
				console.log("updating list");
				listajaxopen = true;					
				//if(objectListIsVisible) { Sourcemap.Collections.hideObjects();}
				$("#object-list").replaceWith(html);
			}
		
	};
	
	var switchPage = function(data) {
		eval(data);
		Sourcemap.Collections.resetMap();
	};
	
	this.resetMap = function() {
		 $('#filter-by').val("");
		$.post(Sourcemap.baseurl+"collections/filterlist", { keyword: '*', type: '*', operator: '=', id: collectionID, offset: offset}, updateList, "html");
		SMap.refreshMap(objectsConfig, otherObjects);
	};
	
	this.nextPage = function() {
		$.post(Sourcemap.baseurl+"collections/getnextpage", { offset: offset, id: collectionID}, switchPage, "text");
	};
	
	this.previousPage = function() {
		$.post(Sourcemap.baseurl+"collections/getprevpage", { offset: offset, id: collectionID}, switchPage, "text");
	};

	this.toggleObjectsVisualization = function() {
		if(	$("#objects-visualization").css("display") == "none") {			
			$("#objects-visualization").slideDown();
		} else {
			$("#objects-visualization").css("display","none");
		}
	};
	
	this.hideObjects = function() {
		$("#objects-visualization").css("display", "none");
	};
	
	this.filterCollection = function() {		
		if($('#filter-by').val() == "") { keyword = "*";}
		else { keyword = $('#filter-by').val(); }
		if(mapajaxopen) {mapkeyword = keyword; mapajaxopen = false; console.log("filter for map " + mapkeyword); $.post(Sourcemap.baseurl+"collections/filtermap", { keyword: keyword, type: type, operator: operator, id: collectionID}, updateMap, "json");}
		if(listajaxopen) {listkeyword = keyword; listajaxopen = false; console.log("filter for list " + listkeyword); $.post(Sourcemap.baseurl+"collections/filterlist", { keyword: keyword, type: type, operator: operator, id: collectionID, offset:-1}, updateList, "html");}
	};
	
	//Show the loading overlay when an ajax call is made
	$('#loading-overlay').ajaxStart(function() {
		$(this).show();
	});
	
	//Hide the loading overlay when an ajax call is made
	$('#loading-overlay').ajaxStop(function() {
		$(this).hide();
	});
	
	//Event handlers
	$("#filter-by").keydown(Sourcemap.Collections.filterCollection);
	$("#filter-button").click(Sourcemap.Collections.filterCollection);
	$(".reset-button").click(Sourcemap.Collections.resetMap);
	$("#filter-close-button").click(Sourcemap.Collections.hideFilter);
	$(".objects-close-button").live("click", Sourcemap.Collections.hideObjects);	
	$(".filter-visualization-button").click(Sourcemap.Collections.toggleFilterVisualization);
	$(".objects-visualization-button").click(Sourcemap.Collections.toggleObjectsVisualization);
	$(".next-button").click(Sourcemap.Collections.nextPage);
	$(".previous-button").click(Sourcemap.Collections.previousPage);
	
	$(".visualization").draggable({ containment: '#map_container', revert: true, handle: '.visualization-menu' });						    
	
  }
};

$(document).ready(function() {
  Sourcemap.Collections.init();
});