/**
 * Sourcemap.Comments: Functionality for user submitted interactions about Sourcemaps.
 * This includes comments, favorites, etc.
 *
 * @version 0.8
 * @author sourcemap@media.mit.edu
 * @package sourcemap
 * @subpackage js
 */

if ( typeof(Sourcemap) == 'undefined' ) {Sourcemap = {};}

Sourcemap.Comments = {
  init: function() {
	this.addFavorite = function() {
		if($("#favorite-button").hasClass("favorited")) { var status = "remove"; }
		else { var status = "add"; }
	    var fav = {
		  id: objectConfig.oid,
		  status: status
      	};
	    var saveData = "data=" + JSON.stringify(fav) + "";	
		Sourcemap.pageTracker._trackEvent("Social", "Favorite", "Favorite on "+objectConfig.oid+"");		
	    $.post(Sourcemap.siteurl+"comments/favorite", saveData, Sourcemap.Comments.favoriteConfirmation );
	};
	this.favoriteConfirmation = function() {
		if($("#favorite-button").hasClass("favorited")) {
			$("#favorite-button").removeClass("favorited");			
		}
		else {
			$("#favorite-button").addClass("favorited");
		}
		Sourcemap.debug("favorited");
	};
	

		
	// this function var is private inside of this Sourcemap.Comments object
	this.saveComment = function() {
	    var newComment = {
		id: objectConfig.oid,
		type: "object",		
		text: Sourcemap.Util.utf8encode($("#submitcommentcontent").val())
	    };
	    var saveData = "data=" + JSON.stringify(newComment) + "";	
	    Sourcemap.pageTracker._trackEvent("Social", "Comment", "Comment "+$("#submitcommentcontent").val()+" on "+objectConfig.oid+"");	
	    $.post(Sourcemap.siteurl+"comments/save", saveData, Sourcemap.Comments.saveConfirmation );
	};
	
	// this function var is private inside of this Sourcemap.Comments object
	this.saveConfirmation = function(md5email) {
	    $(".commentlist").prepend( Sourcemap.Comments.protoComment , {
		    email: md5email,
		    text:$("#submitcommentcontent").val()
		});
	    commentcount = parseInt($("#commentcount").text())+1;
	    $("#commentcount").text(commentcount);
	    $("#submitcommentcontent").val("");
	    
	};
	
	this.protoComment = $.template('<li class="comment"><div class="author"> <img class="authorimage" src="http://www.gravatar.com/avatar/${email}?d=identicon&s=38&r=pg" width="38" height="38" /><br/> </div> <div class="slug"> <strong>You said</strong> </div> <div class="content">${text}</div><div class="clear"></div></li> ');	
	
	$("#submitcommentbutton").click(Sourcemap.Comments.saveComment);
	$("#favorite-button").click(Sourcemap.Comments.addFavorite);
    }
};

$(document).ready(function() {	
	Sourcemap.Comments.init();
    });

