/**
 * Sourcemap.PartEditor: Handles functionality for editing, suggesting and saving new parts.
 *
 * @version 0.8
 * @author sourcemap@media.mit.edu
 * @package sourcemap
 * @subpackage js
 */

if ( typeof(Sourcemap) == 'undefined' ) {Sourcemap = {};}

Sourcemap.PartEditor = {
  init: function() {
		$("#part-list li").each(function() {
			$("div.part-box", this).heatcolor( 
				function() {
					return Sourcemap.Util.roundIt($("span.co2val", this).text(),0)+1;
				},
				{ 
					maxval: 20000,
					minval: 0, 
					reverseOrder: true,
					colorStyle: 'greentored',
					lightness: 0
				}
			);
		});
		
		protoComment = $.template('<li class="comment"><div class="author"> <img class="authorimage" src="http://www.gravatar.com/avatar/${email}?d=identicon&s=38&r=pg" width="38" height="38"/><br/> </div> <div class="slug"> <strong>You said</strong> </div> <div class="content">${text}</div><div class="clear"></div></li> ');	
		$("#submitcommentbutton").click(Sourcemap.PartEditor.saveComment);		
  },
  	
    saveComment: function() {
	    var newComment = {
		  id: $("#partid").text(),
		  type: "part",		
	      text: $("#submitcommentcontent").val()
      };
	    var saveData = "data=" + JSON.stringify(newComment) + "";	
	    $.post(Sourcemap.baseurl+"comments/save", saveData, Sourcemap.PartEditor.saveCommentConfirmation );
    },

    saveCommentConfirmation: function(md5email) {	
		$(".commentlist").prepend( protoComment , {
			email: md5email,
			text:$("#submitcommentcontent").val()
		});
	    $("#submitcommentcontent").val("");

    },	
};

$(document).ready(function() {
	Sourcemap.PartEditor.init();
});
