if ( typeof(Sourcemap) == 'undefined' ) {Sourcemap = {}; }
Sourcemap.Widgets = {};	

Sourcemap.Widgets.LastLegWidget = {
  init: function() {
		if(google.loader.ClientLocation != null) {
			$("#lastleglocation").val(google.loader.ClientLocation.address.city);
		}
		$("#lastlegselect").html($("#object-via").html());
		$("#lastlegselect select").attr("class","lastleglist");

		$( "#lastlegselect select" ).change(function(){ 
			Sourcemap.Widgets.LastLegWidget.calculateLastLeg();
		});
		$( "#lastleglocation" ).change(function(){
			Sourcemap.Widgets.LastLegWidget.calculateLastLeg();
		});	

		//this.calculateLastLeg();
  },
  
	calculateLastLeg: function() {
		objectOrigin = GLatLng.fromUrlValue(objectConfig.latlon.replace(/[|]/g,','));
		SMap.geoCoder.getLocations($("#lastleglocation").val(), function(response){

			if(response.Status.code != 200) {
				SMap.userLocation = null;
				SMap.showUserLocation = false;
				SMap.removeUserLocation();
				SMap.refreshMap();
				return;
			}

			point = new GLatLng(response.Placemark[0].Point.coordinates[1], response.Placemark[0].Point.coordinates[0]);
			place = response.Placemark[0];

			if(point != null && (point.lat() != 0 && point.lng() != 0) && response.Status.code == 200){
				SMap.userLocation = {
					longitude:point.lng(), 
					latitude:point.lat(),
					placename: place.address
				};
				SMap.showUserLocation = true;
				SMap.refreshMap();
				
				$("body").trigger("lastlegGeoMessage", [place.address]); 
				newDistance = Sourcemap.Util.getDistance(objectOrigin, point);

				lastlegemissions = parseFloat(newDistance) * parseFloat(objectConfig.weight/1000) * parseFloat($( "#lastlegselect select" ).val());
				$("#lastlegemissions").text(Sourcemap.Util.roundIt(Number(lastlegemissions)));
			}
			else { /* last leg geoerror*/ }
		});
	}
};

Sourcemap.Widgets.Charting = {
  init: function() {
	this.update = function() {
		objectBreakdown = new Array(0);
		for(var part in objectConfig.parts) {
			if(objectConfig.parts[part].flag != "remove") {
				var transport = Sourcemap.Util.roundIt(Number(objectConfig.parts[part].shipping * (objectConfig.parts[part].weight/1000) * objectConfig.parts[part].transportemissions),2);
				if(objectConfig.parts[part].emissions > 0 || transport > 0) {
					partData = [Number(objectConfig.parts[part].emissions), transport];					
					objectBreakdown.push([partData, {label: objectConfig.parts[part].name}]);
				}
			}
		}
		if(typeof(objectConfig) != 'undefined' && objectBreakdown.length > 0) {
		
		$('#chartgraph').tufteBar({
			data: objectBreakdown,
			barWidth:  function(i) { return 0.5 + (i % 2) * 0.2 },
			barLabel:  function(i) { return Sourcemap.Util.roundIt($(this[0]).sum(),2) },
			axisLabel: function(i) { return this[1].label }, 
			color:     function(i, stackedIndex) { return (this[1].colors || ['#21e010', '#c9ff23', '#21e010'])[stackedIndex % 3] }
		});
		}
	}
	$("body").bind("partAdded", function() { Sourcemap.Widgets.Charting.update(); }); 
	$("body").bind("partRemoved", function() { Sourcemap.Widgets.Charting.update(); });
	$("body").bind("partTotalsChanged", function() { Sourcemap.Widgets.Charting.update(); }); 	
	$("body").bind("partNameUpdated", function() { Sourcemap.Widgets.Charting.update(); });
 	$("body").bind("partEmissionsUpdated", function() { Sourcemap.Widgets.Charting.update(); });
	$("body").bind("partTransportEmissionsUpdated", function() { Sourcemap.Widgets.Charting.update(); });
	this.update();
  }
};

$(document).ready(function() {		
	Sourcemap.Widgets.LastLegWidget.init();
	Sourcemap.Widgets.Charting.init();
});
