DROP TABLE IF EXISTS parts_list;
CREATE TABLE parts_list (
  id serial,
  uid integer DEFAULT NULL,
  class character varying(128) DEFAULT NULL,
  slug character varying(128) NULL,
  name character varying(128) DEFAULT NULL,
  impact decimal(10,4) DEFAULT NULL,
  unit character varying(128) DEFAULT NULL,
  description text,
  rich_description text,
  co2_eq decimal(11,4) DEFAULT NULL,
  modified timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  approval_status character varying(128) DEFAULT NULL,
  CONSTRAINT pk_parts_list PRIMARY KEY (id),
  CONSTRAINT uniq_parts_list_slug UNIQUE (slug)
);

CREATE TRIGGER parts_list_mod
  BEFORE UPDATE
  ON parts_list
  FOR EACH ROW EXECUTE PROCEDURE update_modified_column();
  
GRANT all privileges on parts_list to sourcemap;
GRANT all privileges on parts_list_id_seq to sourcemap;
