<?php
/*
 * Created on Nov 24, 2009
 *
 */
 require_once('../../application/libraries/excel_reader2.php');
 require_once('../../application/libraries/SMPartsParser.php');
 
 $partsParser = new SpreadsheetXLSParser();
 
 $canonical = $partsParser->to_canonical('../data/PartsTest.xls');
 
 $expected = get_expected();

 if (are_equivalent($canonical,$expected)) {
 	echo("expected matched canonical\n");
 } else {
 	$msg = "Expected \n\n[$expected]\n\n" .
 			" but got\n\n[$canonical]\n\n";
 	echo($msg);
 	throw new Exception("expected did not match canonical");	
 }
 
 $parsed_objects = json_decode($canonical);
 $anobject = $parsed_objects[0];
 if (isset($anobject)){
 	echo("created real object \n");
 } else {
 	echo("$canonical \n");
 	throw new Exception("json would not make a valid object");
 }
 
 assert_field($anobject->description,"just to test if this thing works", "description");
 
 $parts = $anobject->partsList;
 if (sizeof($parts) === 2){
 	echo("correct number of parts \n");
 	$part1 = $parts[0];
	 assert_field($part1->name,"Brain", "name");
 	$part2 = $parts[1];
	 assert_field($part2->name,"Heart", "name");
 } else {
 	echo("wrong number of parts.  Expected 2 but got ".sizeof($parts)." \n");
 	throw new Exception("failed field validation on parts");
 }

 function assert_field($actual, $expected, $field_name){
	 if (are_equivalent($actual,$expected)){
	 	echo("valid $field_name '$actual' \n");
	 } else {
	 	echo("wrong $field_name expected '$expected' but got '$actual' \n");
	 	throw new Exception("failed field validation on $field_name");
	 }
 	
 }
 
 function are_equivalent($actual, $expected){
 	$rv = true;
 	$actual_len = strlen($actual);
 	$expected_len = strlen($expected);
 	if ($actual_len != $expected_len){
 		$rv = false;
 		echo 'Two strings are not the same length.  Actual: '.$actual_len.' Expected: '.$expected_len."\n";
 	}	
 	$actual_chars = str_split($actual);
 	$expected_chars = str_split($expected);
	$act_len = sizeof($actual_chars);
	$exp_len = sizeof($expected_chars);
	$mismatch_count = 0;
	$error_msg = "Strings not equal: ...";
	$actual_substring = "";
	$expected_substring = "";
	$start_pos = 0;
	for ($i = 0 ; $i < $act_len && $i < $exp_len ; $i++){
		if ($i > $act_len || $i > $exp_len ||$actual_chars[$i] != $expected_chars[$i]){
			$mismatch_count++;
			if ($mismatch_count < 15){
				if ($i < $actual_len){
					$actual_substring .= $actual_chars[$i];
				}
				if ($i < $expected_len){
					$expected_substring .= $expected_chars[$i];
				} 
			}	
			if ($start_pos == 0){
				$start_pos = $i;
			}
		}
	}
	
	if ($mismatch_count > 0){
		$error_msg .= $actual_substring;
		$error_msg .= "... vs. ...";
		$error_msg .= $expected_substring;
		$error_msg .= "... at position $start_pos ";
		$error_msg .= substr($expected, $start_pos - 10, 30);
		$error_msg .= "\n";
		$rv = false;
		echo $error_msg;
	}
 	return $rv;
 }
 
 function get_expected() {

	$rv = '[{"oid":"",' .
			'"type":"object",' .
			'"flag":"",' .
			'"permissions":":",';
	$rv .= '"name":"A test Map",' .
			'"description":"just to test if this thing works",' .
			'"category":"",'.
			'"upc":"",'.
			'"image_link":"",';
	$rv .= '"origin":"Berkeley, CA",' .
			'"latlon":"0|0",';
	$rv .= '"destination":"",' .
			'"weight":"",' .
			'"emissions":"",';
	$rv .= '"embodied":"",' .
			'"transport":"",' .
			'"shipping":"",';
	$rv .= '"via":"",' .
			'"creator":"Tim Cull",'.
			'"lifetime":"0",' .
			'"usagetype":"",' .
			'"usageenergy":"0",';
	$rv .= '"usageemissions":"0",' .
			'"timecreated":"",';
	$rv .= '"timemodified":"",' .
			'"visibility":"public",';
	$rv .= '"showfootprint":"on",' .
			'"showembodied":"on",' .
			'"showtransport":"on",';
	$rv .= '"showprocess":"on",' .
			'"showendoflife":"on",' .
			'"showlastleg":"on",';
	$rv .= '"showuse":"on",' .
			'"showstats":"on",' .
			'"partsList":[{"name":"Brain",' .
			'"linkid":"0",' .
			'"description":"the nerve center",' .
			'"origin":"San Jose",' .
			'"latlon":"0|0",' .
			'"via":"foot",' .
			'"weight":"5",' .
			'"rawemissions":"999",' .
			'"emissions":"0.1",' .
			'"shipping":"12",' .
			'"transportemissions":"",' .
			'"link":"false"},' .
			'{"name":"Heart",' .
			'"linkid":"0",' .
			'"description":"circulation",' .
			'"origin":"San Jose",' .
			'"latlon":"0|0",' .
			'"via":"car",' .
			'"weight":"5",' .
			'"rawemissions":"999",' .
			'"emissions":"0.1",' .
			'"shipping":"10",' .
			'"transportemissions":"666",' .
			'"link":"false"}],' .
			'"partcount":2},';
	$rv .=	'{"oid":"",' .
			'"type":"object",' .
			'"flag":"",' .
			'"permissions":":",';
	$rv .= '"name":"another test map",' .
			'"description":"just to test if this thing works",' .
			'"category":"",'.
			'"upc":"",'.
			'"image_link":"",';
	$rv .= '"origin":"Berkeley, CA",' .
			'"latlon":"0|0",';
	$rv .= '"destination":"",' .
			'"weight":"",' .
			'"emissions":"",';
	$rv .= '"embodied":"",' .
			'"transport":"",' .
			'"shipping":"",';
	$rv .= '"via":"",' .
			'"creator":"Tim Cull",'.
			'"lifetime":"0",' .
			'"usagetype":"",' .
			'"usageenergy":"0",';
	$rv .= '"usageemissions":"0",' .
			'"timecreated":"",';
	$rv .= '"timemodified":"",' .
			'"visibility":"public",';
	$rv .= '"showfootprint":"on",' .
			'"showembodied":"on",' .
			'"showtransport":"on",';
	$rv .= '"showprocess":"on",' .
			'"showendoflife":"on",' .
			'"showlastleg":"on",';
	$rv .= '"showuse":"on",' .
			'"showstats":"on",' .
			'"partsList":[{"name":"Brain",' .
			'"linkid":"0",' .
			'"description":"the nerve center",' .
			'"origin":"San Jose",' .
			'"latlon":"0|0",' .
			'"via":"container ship",' .
			'"weight":"5",' .
			'"rawemissions":"999",' .
			'"emissions":"0.1",' .
			'"shipping":"12",' .
			'"transportemissions":"",' .
			'"link":"false"},' .
			'{"name":"Heart",' .
			'"linkid":"0",' .
			'"description":"circulation",' .
			'"origin":"San Jose",' .
			'"latlon":"0|0",' .
			'"via":"car",' .
			'"weight":"5",' .
			'"rawemissions":"999",' .
			'"emissions":"0.1",' .
			'"shipping":"10",' .
			'"transportemissions":"666",' .
			'"link":"false"}],' .
			'"partcount":2}'.
			']';
	return $rv;	
 }
?>